<?php

/**
 * $Id: entitylist.php 6820 2007-06-20 13:35:30Z kevin_fourie $
 *
 * The contents of this file are subject to the KnowledgeTree Public
 * License Version 1.1.2 ("License"); You may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.knowledgetree.com/KPL
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
 * See the License for the specific language governing rights and
 * limitations under the License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by KnowledgeTree" logo and
 *    (ii) the KnowledgeTree copyright notice
 * in the same form as they appear in the distribution.  See the License for
 * requirements.
 * 
 * The Original Code is: KnowledgeTree Open Source
 * 
 * The Initial Developer of the Original Code is The Jam Warehouse Software
 * (Pty) Ltd, trading as KnowledgeTree.
 * Portions created by The Jam Warehouse Software (Pty) Ltd are Copyright
 * (C) 2007 The Jam Warehouse Software (Pty) Ltd;
 * All Rights Reserved.
 * Contributor( s): ______________________________________
 *
 */

class KTEntityList {

    var $sCode = null;
    var $aDocumentIds = array();
    var $aFolderIds = array();

    function KTEntityList($aDocumentIds = false, $aFolderIds = false) {
        $this->sCode = KTUtil::randomString();

        if($aDocumentIds !== false) {
            $this->aDocumentIds =& $aDocumentIds;
        }
        if($aFolderIds !== false) {
            $this->aFolderIds =& $aFolderIds;
        }

        $this->serialize();
    }

    // serialize to session
    function serialize() {
        $sList = serialize($this);
        $_SESSION['ktentitylists'][$this->sCode] = $sList;
    }   

    // get the storage code
    function getCode() {
        return $this->sCode;
    }

    function &getDocumentIds() {
        return $this->aDocumentIds;
    }
    function &getFolderIds() {
        return $this->aFolderIds;
    }

    // static accessor
    function &retrieveList($sCode) {
        $sList = KTUtil::arrayGet($_SESSION['ktentitylists'], $sCode, False);
        if($sList === False) {
            return PEAR::raiseError(_kt('No such KTEntityList'));
        }
        $oList = unserialize($sList);
        return $oList;
    }
        
}

?>
